local moduleName = "target"

local L = AceLibrary('AceLocale-2.2'):new('SimpleUnitFrames_Target')

L:RegisterTranslations('enUS', function() return {

	["Target Frame"] = true,
	["Description"] = "Options for the target frame",
	["Health Text"] = true,
	["Mana Text"] = true,
	["Health Text Description"] = "Set health text to one of the formats",
	["Mana Text Description"] = "Set mama text to one of the formats",
	
	
} end)

L:RegisterTranslations('koKR', function() return {

	["Description"] = "대상 프레임에 대한 설정",
	
	["Health Text"] = "생명력 글자",
	["Mana Text"] = "마나 글자",
	["Health Text Description"] = "생명력 글자 표시 방법 선택",
	["Mana Text Description"] = "마나 글자 표시 방법 선택",
	
	
} end)

local Target = SimpleUnitFrames:NewModule(moduleName, "AceEvent-2.0")

Target.core.defaults[moduleName] = {
	hp = "mh3completehp",
	mp = "currmaxmp",
}

local OPTION_ORDER = 100
Target.consoleOptions = {
	type = 'group',
	name = L['Target Frame'],
	desc = L['Description'],
	args = {	
		hp = {
			order = OPTION_ORDER + 1,
			type = 'text',
			name = L['Health Text'],
			desc = L['Health Text Description'],
			get = function() return Target.db.hp end,
			set = function(v) 
							Target.db.hp = v
							Target:UpdateHealth()
						end,
			validate = Target.core.formatList,
		},
		mp = {
			order = OPTION_ORDER + 2,
			type = 'text',
			name = L['Mana Text'],
			desc = L['Mana Text Description'],
			get = function() return Target.db.mp end,
			set = function(v)
							Target.db.mp = v
							Target:UpdateMana()
						end,
			validate = Target.core.formatList,
		},
	}
}

function Target:OnInitialize()	
	TargetDeadText:SetText()
end

function Target:OnEnable()
	self:RegisterEvent("UNIT_HEALTH", "OnHealthChange" )
	self:RegisterEvent("UNIT_MAXHEALTH", "OnHealthChange" )
	self:RegisterEvent("UNIT_MANA", "OnManaChange" )
	self:RegisterEvent("UNIT_MAXMANA", "OnManaChange")
	self:RegisterEvent("UNIT_ENERGY", "OnManaChange")
	self:RegisterEvent("UNIT_MAXENERGY", "OnManaChange")
	self:RegisterEvent("UNIT_RAGE", "OnManaChange")
	self:RegisterEvent("UNIT_MAXRAGE", "OnManaChange")
	self:RegisterEvent("UNIT_DISPLAYPOWER", "OnManaChange")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")	
	self:Refresh()
end


function Target:PLAYER_TARGET_CHANGED()
	self:Refresh()
end

function Target:OnHealthChange(arg1)
	if arg1 == 'target' then
		self:UpdateHealth()
	end
end

function Target:OnManaChange(arg1)
	if arg1 == 'target' then
		self:UpdateMana()
	end
end

function Target:Refresh()
	if UnitExists('target') then
		self:UpdateHealth()
		self:UpdateMana()
	end
end
function Target:UpdateHealth()
	SUF_TargetHealthText:SetText( self:GetValueText('target', self.db.hp) )
end

function Target:UpdateMana()
	SUF_TargetManaText:SetText( self:GetValueText('target', self.db.mp) )
end
